

	
	<table class="form-table" >
		<tbody>
<?php if($credentials_changed && !$app_token_error): ?>
<tr>
    <th scope="col" colspan="3">
        <div class="carerix_msgBox carerix_note">
            Your settings have been changed. The <b>Synchronize new items from Carerix</b> will start now.
            
        </div>
    </th>
</tr>


<?php endif; ?>            
            
			<?php if(@$page_error): ?>
			<tr>
				<th scope="col" colspan="3">
					<div class="carerix_msgBox carerix_error">
					Error: you can not proceed. There are errors on this page.  Please correct these errors and try again.
					</div>
				</th>
			</tr>
			<?php endif; ?>
			<?php if(@$error): ?>
			<tr>
				<th scope="col" colspan="3">
					<div class="carerix_msgBox carerix_error">
						Error: can not connect to the system. The Application Token or the Application Name is not correct.
					</div>
				</th>
			</tr>
			<?php endif; ?>
			<?php if(@$success): ?>
			<tr>
				<th scope="col" colspan="3">
					<div class="carerix_msgBox carerix_ok">
					All settings were succesfully saved.
					</div>
				</th>
			</tr>
			<?php endif; ?>
            <form method="post" class="undoable">
                    <?php wp_nonce_field('settings', '_carerix_nonce_field'); ?>
			<tr valign="top">
				<th scope="col" colspan="3">
					<div class="carerix_msgBox carerix_note">
					Fill in the application name  add the application Token to connect with the Carerix System and click Save.  Follow the steps on the wiki page to generate your token: <a href="http://en.wiki.carerix.com/index.php/Activate_API_for_WordPress_plugin" target="_blank">Generate Token</a>
					</div>
				</th>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="app_name">Carerix Application Name</label>
				</th>
				<td>
					<input name="app_name" type="text" id="app_name" value="<?php echo @$app_name; ?>" class="regular-text <?php if(@$app_name_error) echo "carerix_field_error"; ?>">
					<?php if(@$app_name_error): ?>
						<p class="carerix_field_error">This field is mandatory</p>
					<?php endif; ?>
				</td>
				<td>
					<span style="font-style: italic;">If your system is <b>publictest</b>.carerix.net, the application name is <b>publictest</b> </span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="app_token">Application Token</label>
				</th>
				<td>
					<input name="app_token" type="text" id="app_token" value="<?php echo @$app_token; ?>" class="regular-text <?php if(@$app_name_error) echo "carerix_field_error"; ?>">
					<?php if(@$app_token_error): ?>
					<p class="carerix_field_error">This field is mandatory</p>
					<?php endif; ?>
				</td>
				<td>
					<span style="font-style: italic;">Follow the steps on the wiki page to generate your token: <a href="http://en.wiki.carerix.com/index.php/Activate_API_for_WordPress_plugin" target="_blank">Generate Token</a></span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="app_reporting">Allow the plugin to report its location</label>
				</th>
				<td valign="left" colspan="2">
					<label>
					<input type="checkbox" name="app_reporting" id="app_reporting" <?php echo $checked = @$app_reporting == 'on' ? 'checked' : '';  ?> >
					By reporting its location, we will be able to track if there are any issuess. Therefor the quality of plugin development will be much better.
					</label>
				</td>
			</tr>
            <tr>
                <th scope='row'>
                    <label for='sync_clean'>Clean categories at sync</label>
                </th>
                <td valign='left' colspan='2'>
                    <label>
                        <input type='checkbox' name='sync_clean' id='sync_clean' <?php echo $checked = @$sync_clean == 'on' ? 'checked' : ''; ?> />
                               Empty categories (and with no subcategories) should be removed when items are synchronized
                    </label>
                </td>
            </tr>
            <tr>
                <th scope='row'>
                    <label for='skip_main_category'>Skip main category</label>
                </th>
                <td valign='left' colspan='2'>
                    <label>
                        <input type='checkbox' name='skip_main_category' id='skip_main_category' <?php echo $checked = @$skip_main_category == 'on' ? 'checked' : ''; ?> />
                            Yes, skip the main category. The main (container) category (vacatures/publications) will be removed. All (sub,- and sub-sub-)categories will move 1 step up the hierarchical l ladder. All posts will remain in the same category as before. Be aware that you should check your settings wherever you are showing categories!
                    </label>
                </td>
            </tr>
			<tr valign="top">
				<th scope="row">
				</th>
				<td>
					<p class="submit">
						<input type="submit" name="submit" id="submit" class="button button-primary" value="Save changes">
					</p>
				</td>
			</tr>
            </form>
			<tr valign="top">
				<th scope="col" colspan="3">
			<div class="carerix_msgBox carerix_note">
					Have you made changes in your system and do you want them to be updated now on this website? Click on <b>Synchronize items from Carerix</b> to immediately syncronize with your system. Otherwise they will be updated with the automatic synchronization which takes place every 10 minutes
			</div>
				
					<div id="sync_all_success" class="carerix_msgBox carerix_ok" style="display: none;">
						The synchronization process finished with success
					</div>

					<div id="sync_all_error" class="carerix_msgBox carerix_error" style="display: none;">
						Error: the synchronization process failed. Please try again. If the problem persists please contact your Carerix administrator. 
					</div>
				
                   
				</th>
			</tr>
			<tr valign="top">
				<td>
					<?php
					$disabled = '';
					if(@$error):
						$disabled = 'disabled';
					endif;
					?>

                    <button <?php echo $disabled; ?> id="app_cron" name="sync_now" class="button button-primary <?php echo $disabled; ?>"><i class="fa fa-refresh fa-spin wait" style="display: none;"></i> Synchronize new items from Carerix </button>
                    
                    
				</td>
                <td>
                    <?php
                    $link = get_bloginfo('url') . '/?carerix_sync';
                    ?>
                    Or you can access the following link
                    <a href='<?php echo $link; ?>' target='_blank'><?php echo $link; ?></a>
                </td>
			</tr>
            <tr valign="top">
                <th colspan="3">
                    <div id="jobs_all_progress" class="carerix_msgBox carerix_note" style="display: none;">
						<i class="fa fa-refresh fa-spin wait"></i> The synchronization process for Jobs sources has started 
					</div>
                    
                     <div id="jobs_all_success" class="carerix_msgBox carerix_ok" style="display: none;">
						The synchronization process for Jobs sources finished with success 
					</div>

					<div id="jobs_all_error" class="carerix_msgBox carerix_error" style="display: none;">
						Error: the synchronization process for Jobs sources failed. Please try again. If the problem persists please contact your Carerix administrator. 
					</div>
            
                    <div id="promotionals_all_progress" class="carerix_msgBox carerix_note" style="display: none;">
						<i class="fa fa-refresh fa-spin wait"></i> The synchronization process for Promotional Jobs sources has started 
					</div>
            
                    <div id="promotionals_all_success" class="carerix_msgBox carerix_ok" style="display: none;">
						The synchronization process for Promotional Jobs sources finished with success
					</div>

					<div id="promotionals_all_error" class="carerix_msgBox carerix_error" style="display: none;">
						Error: the synchronization process for Promotional Jobs sources failed. Please try again. If the problem persists please contact your Carerix administrator. 
					</div>
            
                    <div id="candidates_all_progress" class="carerix_msgBox carerix_note" style="display: none;">
						<i class="fa fa-refresh fa-spin wait"></i> The synchronization process for Candidate sources has started 
					</div>
            
                    <div id="candidates_all_success" class="carerix_msgBox carerix_ok" style="display: none;">
						The synchronization process for Candidates sources finished with success
					</div>

					<div id="candidates_all_error" class="carerix_msgBox carerix_error" style="display: none;">
						Error: the synchronization process for Candidates sources failed. Please try again. If the problem persists please contact your Carerix administrator. 
					</div>
            
                    <div id="people_all_progress" class="carerix_msgBox carerix_note" style="display: none;">
						<i class="fa fa-refresh fa-spin wait"></i> The synchronization process for People sources has started 
					</div>
            
                    <div id="people_all_success" class="carerix_msgBox carerix_ok" style="display: none;">
						The synchronization process for People sources finished with success
					</div>

					<div id="people_all_error" class="carerix_msgBox carerix_error" style="display: none;">
						Error: the synchronization process for People sources failed. Please try again. If the problem persists please contact your Carerix administrator. 
					</div>
            
                    <div id="companies_all_progress" class="carerix_msgBox carerix_note" style="display: none;">
						<i class="fa fa-refresh fa-spin wait"></i> The synchronization process for Companies sources has started 
					</div>
            
                    <div id="companies_all_success" class="carerix_msgBox carerix_ok" style="display: none;">
						The synchronization process for Companies sources finished with success
					</div>

					<div id="companies_all_error" class="carerix_msgBox carerix_error" style="display: none;">
						Error: the synchronization process for Companies sources failed. Please try again. If the problem persists please contact your Carerix administrator. 
					</div>
            
                    <div id="newsletters_all_progress" class="carerix_msgBox carerix_note" style="display: none;">
						<i class="fa fa-refresh fa-spin wait"></i> The synchronization process for Newsletters sources has started 
					</div>
            
                    <div id="newsletters_all_success" class="carerix_msgBox carerix_ok" style="display: none;">
						The synchronization process for Newsletters sources finished with success
					</div>

					<div id="newsletters_all_error" class="carerix_msgBox carerix_error" style="display: none;">
						Error: the synchronization process for Newsletters sources failed. Please try again. If the problem persists please contact your Carerix administrator. 
					</div>
                </th>
            </tr>
            <tr valign="top">
                <th colspan="3">
                <div class="carerix_msgBox carerix_note">
                    The reset button will reset your plugin to the default installation, except the App Name and App Token.<br>
                    Every option, source and form will be deleted, leaving only the default ones.<br>
                    Every post and page created automatically by the plugin will be deleted and a resynchronization will be done for the default source.<br>
                </div>
                </th>
            </tr>
            <tr valign="top">
                <th>
                    <button id="reset" name="reset" class="button button-primary"><i class="fa fa-refresh fa-spin wait" style="display: none;"></i><span class='text'>Reset to default</span></button>
                </th>
            </tr>
		</tbody>
	</table>


<script>
    jQuery(document).ready(function(e){
        var $ = jQuery;
        
        $("#app_cron").click(function(e){
            $(this).attr('disabled','disabled');
           $("#sync_all_error").hide();
           $("#sync_all_success").hide();
           e.preventDefault(); 
           var spinner = $(this).find('.wait').show();
           
           var source_types = ['jobs', 'promotionals', 'candidates', 'people', 'companies', 'newsletters'];
           var finished = {};
           
           var setFinished = function(key) {
                   finished[key] = true;
           };
           
           getAllFinished = function() { return finished; };
           
           var errorCount = {};
           var setErrorCount = function(type, step) {
               if(errorCount[type]) {
                   errorCount[type][step] = errorCount[type][step] + 1;
               } else {
                   errorCount[type] = {};
                   errorCount[type][step] = 1;
               }
           };
           
           var getErrorCount = function() { return errorCount; }
           var hasMaximumErrors = function(type, step) {
               var maxErrors = 3;
                if(errorCount[type] && errorCount[type][step] && errorCount[type][step] == maxErrors) {
                   return true;
               }
               return false;
           };
           
           var checkStatusCron = function(){
                var allFinished = true;
                var finished = getAllFinished();
                
                for(var j=0; j < source_types.length; j++) {
                    if(!finished[source_types[j]]) allFinished = false;
                }
                if(allFinished) {
                    spinner.hide();
                    $(self).removeAttr('disabled');
                    
                    $('#reset').removeAttr('disabled');
                    $('#reset').find('.wait').hide();
                    $('#reset').find('.text').html('Reset to default');
                }
           };
           
           var self = this;
           
           var cronFunction = function(source_type, timeout) {
                var progress_selector = "#"+source_type+"_all_progress";
                var error_selector = "#"+source_type+"_all_error";
                var success_selector = "#"+source_type+"_all_success";
           
               $(error_selector).hide();
                $(success_selector).hide();
                $(progress_selector).show();
           
           
               setTimeout(function() {
                    
                    
               
                   var cron = function(source_type, pass){

                            var data = {
                                action: 'sync_all',
                                source_type: source_type,
                                page: pass
                            };
                            var maxError = hasMaximumErrors(source_type, pass);
                            if(maxError)  {
                                $(progress_selector).fadeOut();
                                $(success_selector).fadeOut();
                                $(error_selector).fadeIn();
                                setFinished(source_type);
                                return;
                            }

                            $.post(ajaxurl, data, function(response, status, jqXHR){
                                
                                if(status != 'success' || response == null) {
                                    setErrorCount(source_type, pass);
                                    cron(source_type, pass);
                                    
                                } else {
                                    if(response.sync_success == true) {
                                        if(response.has_more == true) {
                                            cron(source_type, pass+1);
                                        } else {
                                            $(success_selector).fadeIn();
                                            $(error_selector).fadeOut();
                                            $(progress_selector).fadeOut();
                                            setFinished(source_type);
                                        }
                                    } else {
                                        setErrorCount(source_type, pass);
                                        cron(source_type, pass);
                                    }
                                }
                                checkStatusCron();
                                
                            }, 'json').fail(function(jqXHR, textStatus, errorThrown){ 
                                setErrorCount(source_type, pass);
                                cron(source_type, pass);
                                checkStatusCron();
                            });
                       };  
                       cron(source_type, 0);
               }, timeout);
           };
           
           for(var i= 0; i < source_types.length; i++) {
               cronFunction(source_types[i], i * 1000);
           }
           return false;
        });
        
        
        
        $("#reset").click(function(e){
            e.preventDefault;
            
            var self = this;
            $(self).attr('disabled','disabled');
            var spinner = $(this).find('.wait').show();
            var textContainer = $(this).find('.text');
            var data = {
               action: 'reset_all',
           };
           textContainer.html('Resetting to default. Please wait.. ');
            
            var resetCron = function() {
                $.post(ajaxurl, data, function(response, status, jqXHR){
               
                    if(response && response.ok) {
                         spinner.hide();
                         $(self).removeAttr('disabled');
                         $(textContainer).html('Reset process was successful. Starting the synchronize process.. ');
                         $("#app_cron").click();
                    } else {
                        $(textContainer).html('Reset process didn\'t complete. Retrying. Please wait .. ');
                        resetCron();
                         
                    }
               
                }, 'json').fail(function(){
                    $(textContainer).html('Reset process didn\'t complete. Retrying. Please wait .. ');
                    resetCron();
                });
            };
            
           resetCron();
           return false;
        });
        

       <?php if($credentials_changed && !$app_token_error): ?>
        
        $("#app_cron").click();
        
        <?php endif; ?>
    });
</script>